Normalised(
THEORY MagicNumberX IS
  MagicNumber(Machine(atm))==(3.5)
END
&
THEORY UpperLevelX IS
  First_Level(Machine(atm))==(Machine(atm));
  Level(Machine(atm))==(0)
END
&
THEORY LoadedStructureX IS
  Machine(atm)
END
&
THEORY ListSeesX IS
  List_Sees(Machine(atm))==(?)
END
&
THEORY ListUsesX IS
  List_Uses(Machine(atm))==(?)
END
&
THEORY ListIncludesX IS
  Inherited_List_Includes(Machine(atm))==(?);
  List_Includes(Machine(atm))==(?)
END
&
THEORY ListPromotesX IS
  List_Promotes(Machine(atm))==(?)
END
&
THEORY ListExtendsX IS
  List_Extends(Machine(atm))==(?)
END
&
THEORY ListVariablesX IS
  External_Context_List_Variables(Machine(atm))==(?);
  Context_List_Variables(Machine(atm))==(?);
  Abstract_List_Variables(Machine(atm))==(?);
  Local_List_Variables(Machine(atm))==(temps,log,carte_etat,cartes,codice,CashDep,tries,state,Tickets,Bills);
  List_Variables(Machine(atm))==(temps,log,carte_etat,cartes,codice,CashDep,tries,state,Tickets,Bills);
  External_List_Variables(Machine(atm))==(temps,log,carte_etat,cartes,codice,CashDep,tries,state,Tickets,Bills)
END
&
THEORY ListVisibleVariablesX IS
  Inherited_List_VisibleVariables(Machine(atm))==(?);
  Abstract_List_VisibleVariables(Machine(atm))==(?);
  External_List_VisibleVariables(Machine(atm))==(?);
  Expanded_List_VisibleVariables(Machine(atm))==(?);
  List_VisibleVariables(Machine(atm))==(?);
  Internal_List_VisibleVariables(Machine(atm))==(?)
END
&
THEORY ListInvariantX IS
  Gluing_Seen_List_Invariant(Machine(atm))==(btrue);
  Gluing_List_Invariant(Machine(atm))==(btrue);
  Expanded_List_Invariant(Machine(atm))==(btrue);
  Abstract_List_Invariant(Machine(atm))==(btrue);
  Context_List_Invariant(Machine(atm))==(btrue);
  List_Invariant(Machine(atm))==(Bills : NAT & Tickets : NAT & CashDep : NAT & state <: STATE & tries : CARTES --> 0..MAX_TRIES & codice : CARTES --> CODES & cartes : ACCOUNTS -->> CARTES & carte_etat : CARTES --> ETAT_CARTES & temps : NAT & log : NAT +-> LOG)
END
&
THEORY ListAssertionsX IS
  Expanded_List_Assertions(Machine(atm))==(btrue);
  Abstract_List_Assertions(Machine(atm))==(btrue);
  Context_List_Assertions(Machine(atm))==(btrue);
  List_Assertions(Machine(atm))==(btrue)
END
&
THEORY ListInitialisationX IS
  Expanded_List_Initialisation(Machine(atm))==(tries,state,Bills,Tickets,CashDep,codice,cartes,carte_etat,log,temps:={carte1|->0,carte2|->0,carte3|->0},{Stopped},0,0,0,{carte1|->code1,carte2|->code2,carte3|->code3},{acc1|->carte1,acc2|->carte2,acc3|->carte3,acc4|->carte1},{carte1|->carte_out,carte2|->carte_out,carte3|->carte_out},{},1);
  Context_List_Initialisation(Machine(atm))==(skip);
  List_Initialisation(Machine(atm))==(tries:={carte1|->0,carte2|->0,carte3|->0} || state:={Stopped} || Bills:=0 || Tickets:=0 || CashDep:=0 || codice:={carte1|->code1,carte2|->code2,carte3|->code3} || cartes:={acc1|->carte1,acc2|->carte2,acc3|->carte3,acc4|->carte1} || carte_etat:={carte1|->carte_out,carte2|->carte_out,carte3|->carte_out} || log:={} || temps:=1)
END
&
THEORY ListParametersX IS
  List_Parameters(Machine(atm))==(?)
END
&
THEORY ListInstanciatedParametersX END
&
THEORY ListConstraintsX IS
  List_Context_Constraints(Machine(atm))==(btrue);
  List_Constraints(Machine(atm))==(btrue)
END
&
THEORY ListOperationsX IS
  Internal_List_Operations(Machine(atm))==(ATM_Ready,ATM_Stop,InsertCard,PIN_req,Withdraw,Transfert,Deposit,Consult,withdraw_card);
  List_Operations(Machine(atm))==(ATM_Ready,ATM_Stop,InsertCard,PIN_req,Withdraw,Transfert,Deposit,Consult,withdraw_card)
END
&
THEORY ListInputX IS
  List_Input(Machine(atm),ATM_Ready)==(bills_number,tickets_number,dep_number);
  List_Input(Machine(atm),ATM_Stop)==(?);
  List_Input(Machine(atm),InsertCard)==(carte,approval);
  List_Input(Machine(atm),PIN_req)==(code,approval);
  List_Input(Machine(atm),Withdraw)==(montant,account,approval);
  List_Input(Machine(atm),Transfert)==(montant,from_account,to_account,approval);
  List_Input(Machine(atm),Deposit)==(montant,account,approval);
  List_Input(Machine(atm),Consult)==(account,approval);
  List_Input(Machine(atm),withdraw_card)==(?)
END
&
THEORY ListOutputX IS
  List_Output(Machine(atm),ATM_Ready)==(msg);
  List_Output(Machine(atm),ATM_Stop)==(msg);
  List_Output(Machine(atm),InsertCard)==(msg);
  List_Output(Machine(atm),PIN_req)==(msg,msg1,msg2);
  List_Output(Machine(atm),Withdraw)==(msg);
  List_Output(Machine(atm),Transfert)==(msg);
  List_Output(Machine(atm),Deposit)==(msg);
  List_Output(Machine(atm),Consult)==(msg1,msg2);
  List_Output(Machine(atm),withdraw_card)==(msg)
END
&
THEORY ListHeaderX IS
  List_Header(Machine(atm),ATM_Ready)==(msg <-- ATM_Ready(bills_number,tickets_number,dep_number));
  List_Header(Machine(atm),ATM_Stop)==(msg <-- ATM_Stop);
  List_Header(Machine(atm),InsertCard)==(msg <-- InsertCard(carte,approval));
  List_Header(Machine(atm),PIN_req)==(msg,msg1,msg2 <-- PIN_req(code,approval));
  List_Header(Machine(atm),Withdraw)==(msg <-- Withdraw(montant,account,approval));
  List_Header(Machine(atm),Transfert)==(msg <-- Transfert(montant,from_account,to_account,approval));
  List_Header(Machine(atm),Deposit)==(msg <-- Deposit(montant,account,approval));
  List_Header(Machine(atm),Consult)==(msg1,msg2 <-- Consult(account,approval));
  List_Header(Machine(atm),withdraw_card)==(msg <-- withdraw_card)
END
&
THEORY ListPreconditionX IS
  List_Precondition(Machine(atm),ATM_Ready)==(card(carte_etat|>{carte_in}) = 0 & state = {Stopped} & bills_number : NAT & Bills+bills_number<=500 & tickets_number : NAT & Tickets+tickets_number<=500 & dep_number : NAT & CashDep+dep_number<=500 & temps<=500);
  List_Precondition(Machine(atm),ATM_Stop)==(card(carte_etat|>{carte_in}) = 0 & state = {Ready} & temps<=500);
  List_Precondition(Machine(atm),InsertCard)==(approval : AUTHORISATION & state = {Ready} & carte : CARTES & card(carte_etat|>{carte_in}) = 0);
  List_Precondition(Machine(atm),PIN_req)==(state = {PIN_request} & code : CODES & approval : AUTHORISATION & card(carte_etat|>{carte_in}) = 1 & temps<=500);
  List_Precondition(Machine(atm),Withdraw)==(state = {In_session} & montant : NAT & account : ACCOUNTS & approval : AUTHORISATION & dom(carte_etat|>{carte_in}) <: ran({account}<|cartes) & card(carte_etat|>{carte_in}) = 1 & temps<=500);
  List_Precondition(Machine(atm),Transfert)==(montant : NAT & from_account : ACCOUNTS & to_account : ACCOUNTS & from_account/=to_account & dom(carte_etat|>{carte_in}) <: ran({from_account}<|cartes) & dom(carte_etat|>{carte_in}) <: ran({to_account}<|cartes) & cartes(from_account) = cartes(to_account) & approval : AUTHORISATION & state = {In_session} & temps<=500);
  List_Precondition(Machine(atm),Deposit)==(montant : NAT & account : ACCOUNTS & dom(carte_etat|>{carte_in}) <: ran({account}<|cartes) & approval : AUTHORISATION & state = {In_session} & temps<=500);
  List_Precondition(Machine(atm),Consult)==(account : ACCOUNTS & approval : AUTHORISATION & state = {In_session} & dom(carte_etat|>{carte_in}) <: ran({account}<|cartes) & temps<=500);
  List_Precondition(Machine(atm),withdraw_card)==(card(carte_etat|>{carte_in}) = 1 & (state = {In_session} or state = {PIN_request}) & temps<=500)
END
&
THEORY ListSubstitutionX IS
  Expanded_List_Substitution(Machine(atm),withdraw_card)==(card(carte_etat|>{carte_in}) = 1 & (state = {In_session} or state = {PIN_request}) & temps<=500 | @carte.(carte : CARTES & carte : dom(carte_etat|>{carte_in}) ==> msg,carte_etat,state:=withdrawed_card,carte_etat<+{carte|->carte_out},{Ready}));
  Expanded_List_Substitution(Machine(atm),Consult)==(account : ACCOUNTS & approval : AUTHORISATION & state = {In_session} & dom(carte_etat|>{carte_in}) <: ran({account}<|cartes) & temps<=500 | approval = yes ==> (Tickets-1>=0 ==> (msg1,Tickets:=consult_message,Tickets-1 || (Tickets = 0 ==> state,msg2:={Stopped},consult_err_message [] not(Tickets = 0) ==> state:={In_session})) [] not(Tickets-1>=0) ==> skip) [] not(approval = yes) ==> skip);
  Expanded_List_Substitution(Machine(atm),Deposit)==(montant : NAT & account : ACCOUNTS & dom(carte_etat|>{carte_in}) <: ran({account}<|cartes) & approval : AUTHORISATION & state = {In_session} & temps<=500 | approval = yes ==> (CashDep-1>=0 & Tickets-1>=0 ==> (CashDep,Tickets,msg,log,temps:=CashDep-1,Tickets-1,deposit_ok_message,log<+{temps|->requestauth,temps+1|->yesauth},temps+2 || (CashDep = 0 or Tickets = 0 ==> state:={Stopped} [] not(CashDep = 0 or Tickets = 0) ==> state:={In_session})) [] not(CashDep-1>=0 & Tickets-1>=0) ==> skip) [] not(approval = yes) ==> msg,log,temps:=deposit_err_message,log<+{temps|->requestauth,temps+1|->noauth},temps+2);
  Expanded_List_Substitution(Machine(atm),Transfert)==(montant : NAT & from_account : ACCOUNTS & to_account : ACCOUNTS & from_account/=to_account & dom(carte_etat|>{carte_in}) <: ran({from_account}<|cartes) & dom(carte_etat|>{carte_in}) <: ran({to_account}<|cartes) & cartes(from_account) = cartes(to_account) & approval : AUTHORISATION & state = {In_session} & temps<=500 | approval = yes ==> (Tickets-1>=0 ==> (Tickets,msg,log,temps:=Tickets-1,transfert_ok_message,log<+{temps|->requestauth,temps+1|->yesauth},temps+2 || (Tickets = 0 ==> state:={Stopped} [] not(Tickets = 0) ==> state:={In_session})) [] not(Tickets-1>=0) ==> msg,log,temps:=transfert_err_message,log<+{temps|->requestauth,temps+1|->noauth},temps+2) [] not(approval = yes) ==> skip);
  Expanded_List_Substitution(Machine(atm),Withdraw)==(state = {In_session} & montant : NAT & account : ACCOUNTS & approval : AUTHORISATION & dom(carte_etat|>{carte_in}) <: ran({account}<|cartes) & card(carte_etat|>{carte_in}) = 1 & temps<=500 | approval = yes ==> (montant mod 20/=0 ==> msg:=only_20moltips_message [] not(montant mod 20/=0) ==> (Bills-montant/20>=0 & Tickets-1>=0 ==> (Bills,Tickets,msg:=Bills-montant/20,Tickets-1,withdraw_ok_message || (Bills = 0 or Tickets = 0 ==> state,log,temps:={Stopped},log<+{temps|->requestauth,temps+1|->yesauth},temps+2 [] not(Bills = 0 or Tickets = 0) ==> state,log,temps:={In_session},log<+{temps|->requestauth,temps+1|->yesauth,temps+2|->withdraw},temps+3)) [] not(Bills-montant/20>=0 & Tickets-1>=0) ==> msg,log,temps:=only_20moltips_message,log<+{temps|->requestauth,temps+1|->yesauth},temps+2)) [] not(approval = yes) ==> msg:=withdraw_err_message);
  Expanded_List_Substitution(Machine(atm),PIN_req)==(state = {PIN_request} & code : CODES & approval : AUTHORISATION & card(carte_etat|>{carte_in}) = 1 & temps<=500 | approval = yes ==> @carte.(carte : CARTES & carte : dom(carte_etat|>{carte_in}) ==> (codice(carte) = code ==> tries,msg2,state,log,temps:=tries<+{carte|->0},okauth_message,{In_session},log<+{temps|->okpinauth,temps+1|->yesokpinauth},temps+2 [] not(codice(carte) = code) ==> (msg2:=code_request_err || (tries(carte)>=MAX_TRIES-1 ==> msg1,state,carte_etat:=card_retained,{Ready},carte_etat<+{carte|->carte_out} [] not(tries(carte)>=MAX_TRIES-1) ==> tries,msg,log,temps:=tries<+{carte|->tries(carte)+1},error_code_message,log<+{temps|->okpinauth,temps+1|->nookpinauth},temps+2)))) [] not(approval = yes) ==> msg2:=code_request_message);
  Expanded_List_Substitution(Machine(atm),InsertCard)==(approval : AUTHORISATION & state = {Ready} & carte : CARTES & card(carte_etat|>{carte_in}) = 0 | approval = yes ==> carte_etat,state,msg:=carte_etat<+{carte|->carte_in},{PIN_request},code_request_message [] not(approval = yes) ==> msg:=no_approval_message);
  Expanded_List_Substitution(Machine(atm),ATM_Stop)==(card(carte_etat|>{carte_in}) = 0 & state = {Ready} & temps<=500 | state,msg,log,temps:={Stopped},stop_message,log<+{temps|->atmstop},temps+1);
  Expanded_List_Substitution(Machine(atm),ATM_Ready)==(card(carte_etat|>{carte_in}) = 0 & state = {Stopped} & bills_number : NAT & Bills+bills_number<=500 & tickets_number : NAT & Tickets+tickets_number<=500 & dep_number : NAT & CashDep+dep_number<=500 & temps<=500 | state,Bills,Tickets,CashDep,msg,log,temps:={Ready},Bills+bills_number,Tickets+tickets_number,CashDep+dep_number,ready_message,log<+{temps|->atmstart},temps+1);
  List_Substitution(Machine(atm),ATM_Ready)==(state:={Ready} || Bills:=Bills+bills_number || Tickets:=Tickets+tickets_number || CashDep:=CashDep+dep_number || msg:=ready_message || log:=log<+{temps|->atmstart} || temps:=temps+1);
  List_Substitution(Machine(atm),ATM_Stop)==(state:={Stopped} || msg:=stop_message || log:=log<+{temps|->atmstop} || temps:=temps+1);
  List_Substitution(Machine(atm),InsertCard)==(IF approval = yes THEN carte_etat(carte):=carte_in || state:={PIN_request} || msg:=code_request_message ELSE msg:=no_approval_message END);
  List_Substitution(Machine(atm),PIN_req)==(IF approval = yes THEN ANY carte WHERE carte : CARTES & carte : dom(carte_etat|>{carte_in}) THEN IF codice(carte) = code THEN tries(carte):=0 || msg2:=okauth_message || state:={In_session} || log:=log<+{temps|->okpinauth,temps+1|->yesokpinauth} || temps:=temps+2 ELSE msg2:=code_request_err || IF tries(carte)>=MAX_TRIES-1 THEN msg1:=card_retained || state:={Ready} || carte_etat(carte):=carte_out ELSE tries(carte):=tries(carte)+1 || msg:=error_code_message || log:=log<+{temps|->okpinauth,temps+1|->nookpinauth} || temps:=temps+2 END END END ELSE msg2:=code_request_message END);
  List_Substitution(Machine(atm),Withdraw)==(IF approval = yes THEN IF montant mod 20/=0 THEN msg:=only_20moltips_message ELSIF Bills-montant/20>=0 & Tickets-1>=0 THEN Bills:=Bills-montant/20 || Tickets:=Tickets-1 || msg:=withdraw_ok_message || IF Bills = 0 or Tickets = 0 THEN state:={Stopped} || log:=log<+{temps|->requestauth,temps+1|->yesauth} || temps:=temps+2 ELSE state:={In_session} || log:=log<+{temps|->requestauth,temps+1|->yesauth,temps+2|->withdraw} || temps:=temps+3 END ELSE msg:=only_20moltips_message || log:=log<+{temps|->requestauth,temps+1|->yesauth} || temps:=temps+2 END ELSE msg:=withdraw_err_message END);
  List_Substitution(Machine(atm),Transfert)==(IF approval = yes THEN IF Tickets-1>=0 THEN Tickets:=Tickets-1 || msg:=transfert_ok_message || log:=log<+{temps|->requestauth,temps+1|->yesauth} || temps:=temps+2 || IF Tickets = 0 THEN state:={Stopped} ELSE state:={In_session} END ELSE msg:=transfert_err_message || log:=log<+{temps|->requestauth,temps+1|->noauth} || temps:=temps+2 END END);
  List_Substitution(Machine(atm),Deposit)==(IF approval = yes THEN IF CashDep-1>=0 & Tickets-1>=0 THEN CashDep:=CashDep-1 || Tickets:=Tickets-1 || msg:=deposit_ok_message || log:=log<+{temps|->requestauth,temps+1|->yesauth} || temps:=temps+2 || IF CashDep = 0 or Tickets = 0 THEN state:={Stopped} ELSE state:={In_session} END END ELSE msg:=deposit_err_message || log:=log<+{temps|->requestauth,temps+1|->noauth} || temps:=temps+2 END);
  List_Substitution(Machine(atm),Consult)==(IF approval = yes THEN IF Tickets-1>=0 THEN msg1:=consult_message || Tickets:=Tickets-1 || IF Tickets = 0 THEN state:={Stopped} || msg2:=consult_err_message ELSE state:={In_session} END END END);
  List_Substitution(Machine(atm),withdraw_card)==(ANY carte WHERE carte : CARTES & carte : dom(carte_etat|>{carte_in}) THEN msg:=withdrawed_card || carte_etat(carte):=carte_out || state:={Ready} END)
END
&
THEORY ListConstantsX IS
  List_Valuable_Constants(Machine(atm))==(MAX_TRIES);
  Inherited_List_Constants(Machine(atm))==(?);
  List_Constants(Machine(atm))==(MAX_TRIES)
END
&
THEORY ListSetsX IS
  Set_Definition(Machine(atm),ACCOUNTS)==({acc1,acc2,acc3,acc4});
  Context_List_Enumerated(Machine(atm))==(?);
  Context_List_Defered(Machine(atm))==(?);
  Context_List_Sets(Machine(atm))==(?);
  List_Valuable_Sets(Machine(atm))==(?);
  Inherited_List_Enumerated(Machine(atm))==(?);
  Inherited_List_Defered(Machine(atm))==(?);
  Inherited_List_Sets(Machine(atm))==(?);
  List_Enumerated(Machine(atm))==(ACCOUNTS,CODES,CARTES,ETAT_CARTES,AUTHORISATION,STATE,MESSAGES,LOG);
  List_Defered(Machine(atm))==(?);
  List_Sets(Machine(atm))==(ACCOUNTS,CODES,CARTES,ETAT_CARTES,AUTHORISATION,STATE,MESSAGES,LOG);
  Set_Definition(Machine(atm),CODES)==({code1,code2,code3});
  Set_Definition(Machine(atm),CARTES)==({carte1,carte2,carte3});
  Set_Definition(Machine(atm),ETAT_CARTES)==({carte_in,carte_out});
  Set_Definition(Machine(atm),AUTHORISATION)==({yes,no});
  Set_Definition(Machine(atm),STATE)==({Ready,Stopped,PIN_request,In_session});
  Set_Definition(Machine(atm),MESSAGES)==({card_retained,ready_message,code_request_message,stop_message,no_approval_message,ppin_err_message,deposit_err_message,withdraw_ok_message,withdraw_err_message,transfert_ok_message,transfert_err_message,deposit_ok_message,deposit_err_mesage,consult_message,consult_err_message,only_20moltips_message,okauth_message,error_code_message,code_request_err,withdrawed_card});
  Set_Definition(Machine(atm),LOG)==({atmstart,atmstop,requestauth,noauth,yesauth,okpinauth,yesokpinauth,nookpinauth,withdraw,deposit})
END
&
THEORY ListHiddenConstantsX IS
  Abstract_List_HiddenConstants(Machine(atm))==(?);
  Expanded_List_HiddenConstants(Machine(atm))==(?);
  List_HiddenConstants(Machine(atm))==(?);
  External_List_HiddenConstants(Machine(atm))==(?)
END
&
THEORY ListPropertiesX IS
  Abstract_List_Properties(Machine(atm))==(btrue);
  Context_List_Properties(Machine(atm))==(btrue);
  Inherited_List_Properties(Machine(atm))==(btrue);
  List_Properties(Machine(atm))==(MAX_TRIES = 3 & not(ACCOUNTS = {}) & not(CODES = {}) & not(CARTES = {}) & not(ETAT_CARTES = {}) & not(AUTHORISATION = {}) & not(STATE = {}) & not(MESSAGES = {}) & not(LOG = {}))
END
&
THEORY ListSeenInfoX END
&
THEORY ListOfIdsX IS
  List_Of_Ids(Machine(atm)) == (MAX_TRIES,ACCOUNTS,CODES,CARTES,ETAT_CARTES,AUTHORISATION,STATE,MESSAGES,LOG,acc1,acc2,acc3,acc4,code1,code2,code3,carte1,carte2,carte3,carte_in,carte_out,yes,no,Ready,Stopped,PIN_request,In_session,card_retained,ready_message,code_request_message,stop_message,no_approval_message,ppin_err_message,deposit_err_message,withdraw_ok_message,withdraw_err_message,transfert_ok_message,transfert_err_message,deposit_ok_message,deposit_err_mesage,consult_message,consult_err_message,only_20moltips_message,okauth_message,error_code_message,code_request_err,withdrawed_card,atmstart,atmstop,requestauth,noauth,yesauth,okpinauth,yesokpinauth,nookpinauth,withdraw,deposit | ? | temps,log,carte_etat,cartes,codice,CashDep,tries,state,Tickets,Bills | ? | ATM_Ready,ATM_Stop,InsertCard,PIN_req,Withdraw,Transfert,Deposit,Consult,withdraw_card | ? | ? | ? | atm);
  List_Of_HiddenCst_Ids(Machine(atm)) == (? | ?);
  List_Of_VisibleCst_Ids(Machine(atm)) == (MAX_TRIES);
  List_Of_VisibleVar_Ids(Machine(atm)) == (? | ?);
  List_Of_Ids_SeenBNU(Machine(atm)) == (? : ?)
END
&
THEORY SetsEnvX IS
  Sets(Machine(atm)) == (Type(ACCOUNTS) == Cst(SetOf(etype(ACCOUNTS,0,3)));Type(CODES) == Cst(SetOf(etype(CODES,0,2)));Type(CARTES) == Cst(SetOf(etype(CARTES,0,2)));Type(ETAT_CARTES) == Cst(SetOf(etype(ETAT_CARTES,0,1)));Type(AUTHORISATION) == Cst(SetOf(etype(AUTHORISATION,0,1)));Type(STATE) == Cst(SetOf(etype(STATE,0,3)));Type(MESSAGES) == Cst(SetOf(etype(MESSAGES,0,19)));Type(LOG) == Cst(SetOf(etype(LOG,0,9))))
END
&
THEORY ConstantsEnvX IS
  Constants(Machine(atm)) == (Type(acc1) == Cst(etype(ACCOUNTS,0,3));Type(acc2) == Cst(etype(ACCOUNTS,0,3));Type(acc3) == Cst(etype(ACCOUNTS,0,3));Type(acc4) == Cst(etype(ACCOUNTS,0,3));Type(code1) == Cst(etype(CODES,0,2));Type(code2) == Cst(etype(CODES,0,2));Type(code3) == Cst(etype(CODES,0,2));Type(carte1) == Cst(etype(CARTES,0,2));Type(carte2) == Cst(etype(CARTES,0,2));Type(carte3) == Cst(etype(CARTES,0,2));Type(carte_in) == Cst(etype(ETAT_CARTES,0,1));Type(carte_out) == Cst(etype(ETAT_CARTES,0,1));Type(yes) == Cst(etype(AUTHORISATION,0,1));Type(no) == Cst(etype(AUTHORISATION,0,1));Type(Ready) == Cst(etype(STATE,0,3));Type(Stopped) == Cst(etype(STATE,0,3));Type(PIN_request) == Cst(etype(STATE,0,3));Type(In_session) == Cst(etype(STATE,0,3));Type(card_retained) == Cst(etype(MESSAGES,0,19));Type(ready_message) == Cst(etype(MESSAGES,0,19));Type(code_request_message) == Cst(etype(MESSAGES,0,19));Type(stop_message) == Cst(etype(MESSAGES,0,19));Type(no_approval_message) == Cst(etype(MESSAGES,0,19));Type(ppin_err_message) == Cst(etype(MESSAGES,0,19));Type(deposit_err_message) == Cst(etype(MESSAGES,0,19));Type(withdraw_ok_message) == Cst(etype(MESSAGES,0,19));Type(withdraw_err_message) == Cst(etype(MESSAGES,0,19));Type(transfert_ok_message) == Cst(etype(MESSAGES,0,19));Type(transfert_err_message) == Cst(etype(MESSAGES,0,19));Type(deposit_ok_message) == Cst(etype(MESSAGES,0,19));Type(deposit_err_mesage) == Cst(etype(MESSAGES,0,19));Type(consult_message) == Cst(etype(MESSAGES,0,19));Type(consult_err_message) == Cst(etype(MESSAGES,0,19));Type(only_20moltips_message) == Cst(etype(MESSAGES,0,19));Type(okauth_message) == Cst(etype(MESSAGES,0,19));Type(error_code_message) == Cst(etype(MESSAGES,0,19));Type(code_request_err) == Cst(etype(MESSAGES,0,19));Type(withdrawed_card) == Cst(etype(MESSAGES,0,19));Type(atmstart) == Cst(etype(LOG,0,9));Type(atmstop) == Cst(etype(LOG,0,9));Type(requestauth) == Cst(etype(LOG,0,9));Type(noauth) == Cst(etype(LOG,0,9));Type(yesauth) == Cst(etype(LOG,0,9));Type(okpinauth) == Cst(etype(LOG,0,9));Type(yesokpinauth) == Cst(etype(LOG,0,9));Type(nookpinauth) == Cst(etype(LOG,0,9));Type(withdraw) == Cst(etype(LOG,0,9));Type(deposit) == Cst(etype(LOG,0,9));Type(MAX_TRIES) == Cst(btype(INTEGER,?,?)))
END
&
THEORY VariablesEnvX IS
  Variables(Machine(atm)) == (Type(temps) == Mvl(btype(INTEGER,?,?));Type(log) == Mvl(SetOf(btype(INTEGER,?,?)*etype(LOG,?,?)));Type(carte_etat) == Mvl(SetOf(etype(CARTES,0,2)*etype(ETAT_CARTES,0,1)));Type(cartes) == Mvl(SetOf(etype(ACCOUNTS,0,3)*etype(CARTES,0,2)));Type(codice) == Mvl(SetOf(etype(CARTES,0,2)*etype(CODES,0,2)));Type(CashDep) == Mvl(btype(INTEGER,?,?));Type(tries) == Mvl(SetOf(etype(CARTES,0,2)*btype(INTEGER,0,MAX_TRIES)));Type(state) == Mvl(SetOf(etype(STATE,?,?)));Type(Tickets) == Mvl(btype(INTEGER,?,?));Type(Bills) == Mvl(btype(INTEGER,?,?)))
END
&
THEORY OperationsEnvX IS
  Operations(Machine(atm)) == (Type(withdraw_card) == Cst(etype(MESSAGES,?,?),No_type);Type(Consult) == Cst(etype(MESSAGES,?,?)*etype(MESSAGES,?,?),etype(ACCOUNTS,?,?)*etype(AUTHORISATION,?,?));Type(Deposit) == Cst(etype(MESSAGES,?,?),btype(INTEGER,?,?)*etype(ACCOUNTS,?,?)*etype(AUTHORISATION,?,?));Type(Transfert) == Cst(etype(MESSAGES,?,?),btype(INTEGER,?,?)*etype(ACCOUNTS,?,?)*etype(ACCOUNTS,?,?)*etype(AUTHORISATION,?,?));Type(Withdraw) == Cst(etype(MESSAGES,?,?),btype(INTEGER,?,?)*etype(ACCOUNTS,?,?)*etype(AUTHORISATION,?,?));Type(PIN_req) == Cst(etype(MESSAGES,?,?)*etype(MESSAGES,?,?)*etype(MESSAGES,?,?),etype(CODES,?,?)*etype(AUTHORISATION,?,?));Type(InsertCard) == Cst(etype(MESSAGES,?,?),etype(CARTES,?,?)*etype(AUTHORISATION,?,?));Type(ATM_Stop) == Cst(etype(MESSAGES,?,?),No_type);Type(ATM_Ready) == Cst(etype(MESSAGES,?,?),btype(INTEGER,?,?)*btype(INTEGER,?,?)*btype(INTEGER,?,?)))
END
&
THEORY TCIntRdX IS
  predB0 == OK;
  extended_sees == KO;
  B0check_tab == KO;
  local_op == OK;
  abstract_constants_visible_in_values == KO
END
)
